unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, extctrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  //array of images which represents blocks
  blocks:array of TImage;
  bounding_boxes:array of TRect;
  sirina,visina:integer;

implementation

{$R *.dfm}

function IsMoveAvailable(x,y:integer):boolean;
var loop:integer;
    bbox,nepotrebni_rect:TRect;
begin
//suppose that move is available
result:=true;
//create temporary bounding box on coordinates where player will be moved
bbox:=Rect(x,y,x+sirina,y+visina);
//pass through all bounding boxes(images) and check for collision
// if dem intersect then result is FALSE
  for loop := low(bounding_boxes) to high(bounding_boxes) do begin
  result := not IntersectRect(nepotrebni_rect,bbox,bounding_boxes[loop]);
  end;
end;

function LoadWorld(matrix_file,graphics_directory,bitmap_extension:string;block_width,block_height:integer;parent:TForm):boolean;
var
  //variables for filesize
  nSize:integer;
  hfile:thandle;
  strSize:string;
  //variables for loading into buffer
  p:char;
  buffer:string;
  a:textfile;
  //for going through matrix
  loop:integer;
  trenutni_red,trenutna_kolona:integer;
  //help variables for easier preview of code
  x,y,x1,y1:integer;
begin
//global vars
sirina:=block_width;
visina:=block_height;
//suppose that there was error
  Result:=false;
//get file size
  hfile:=CreateFile(pchar(matrix_file),0,FILE_SHARE_READ,nil,OPEN_EXISTING,0,0);
  nSize:=GetFileSize(hfile,nil);
  CloseHandle(hfile);
  SetLength(strSize,20);
  Str(nSize,strSize);
//set number of blocks to filesize (that's max)
  SetLength(blocks,StrToInt(strSize));
  SetLength(bounding_boxes,StrToInt(strSize));
//load file into buffer
  assignfile(a,matrix_file);
  reset(a);
      while not Eof(a) do
      begin
        Read(a, p);
        buffer:=buffer+p;
      end;
  closefile(a);
//now we need to go through matrix and to create images
trenutni_red:=0;
trenutna_kolona:=0;
 for loop:=1 to Length(buffer) do begin
 //increase column on every step
 Inc(trenutna_kolona);
   //when reach #13#10 (eoln) then reset column and increase row
   if buffer[loop]+buffer[loop+1] = #13#10 then begin
   trenutna_kolona:=0;
   Inc(trenutni_red);
   end;
  //now create images
  if (buffer[loop] <> ' ') and (buffer[loop] <> #13) and (buffer[loop] <> #10) then begin
    blocks[loop] := TImage.Create(parent);
    blocks[loop].Parent := parent;
    blocks[loop].Width := block_width;
    blocks[loop].Height := block_height;
    blocks[loop].Left := (trenutna_kolona * block_width) - (block_width * 2);
    blocks[loop].Top := trenutni_red * block_height;
    blocks[loop].Transparent := true;
    blocks[loop].AutoSize := false;
    blocks[loop].Stretch := true;
    blocks[loop].Visible := true;
    blocks[loop].Picture.RegisterFileFormat(bitmap_extension,'Bitmap file',TBitmap);
      if graphics_directory <> '' then blocks[loop].Picture.LoadFromFile(graphics_directory+'\'+buffer[loop]+'.'+bitmap_extension)
        else blocks[loop].Picture.LoadFromFile(buffer[loop]+'.'+bitmap_extension);
    x:=(trenutna_kolona * block_width) - (block_width * 2);
    y:=trenutni_red * block_height;
    x1:=x+block_width;
    y1:=y+block_height;
    bounding_boxes[loop]:=Rect(x,y,x1,y1);
  end;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
LoadWorld('test.mtx','data','img',32,32,Form1);
//cisto da obojimo (test)
Image1.Canvas.FloodFill(1,1,clWhite,fsSurface);
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var x,y,step:integer;
tmp:boolean;
begin
//pronalazimo poziciju
x:=Image1.Left; y:=Image1.Top;
//definisemo 'korak' u pikselima
step:=3;
//izvrsavamo pomeraj ako je moguc
  case key of
    VK_UP : if IsMoveAvailable(x,y-step) then Image1.Top:=y-step;
    VK_DOWN : if IsMoveAvailable(x,y+step) then Image1.Top:=y+step;
    VK_LEFT : if IsMoveAvailable(x-step,y) then Image1.Left:=x-step;
    VK_RIGHT : if IsMoveAvailable(x+step,y) then Image1.Left:=x+step;
  end;
//ispishemo
tmp:=IsMoveAvailable(x,y-step);
form1.Canvas.TextOut(300,300,BoolToStr(tmp,true));
end;

end.
